/* CyberTwin */

#import <Cocoa/Cocoa.h>
#import <CoreMIDI/MIDIServices.h>

@interface CyberTwin : NSObject
{
    IBOutlet NSMatrix *amp_compressorselection;
    IBOutlet NSMatrix *amp_drivecircuitry;
    IBOutlet NSTextField *amp_noisegatedepthfield;
    IBOutlet NSStepper *amp_noisegatedepthselection;
    IBOutlet NSMatrix *amp_noisegatethresholdselection;
    IBOutlet NSMatrix *amp_speakerphaseselection;
    IBOutlet NSMatrix *amp_timbreselection;
    IBOutlet NSMatrix *amp_tonestackposition;
    IBOutlet NSMatrix *amp_tonestacktype;
    IBOutlet NSMenuItem *autoReceive;
    IBOutlet NSMenuItem *autoSend;
    IBOutlet NSTextField *comment;
    IBOutlet NSTextField *effects_fieldfxlevel;
    IBOutlet NSTextField *effects_fieldfxval1;
    IBOutlet NSTextField *effects_fieldfxval2;
    IBOutlet NSTextField *effects_fieldfxval3;
    IBOutlet NSTextField *effects_fieldfxval4;
    IBOutlet NSStepper *effects_fxlevel;
    IBOutlet NSStepper *effects_fxval1;
    IBOutlet NSStepper *effects_fxval2;
    IBOutlet NSStepper *effects_fxval3;
    IBOutlet NSStepper *effects_fxval4;
    IBOutlet NSTextField *effects_textfxlevel;
    IBOutlet NSTextField *effects_textfxval1;
    IBOutlet NSTextField *effects_textfxval2;
    IBOutlet NSTextField *effects_textfxval3;
    IBOutlet NSTextField *effects_textfxval4;
    IBOutlet NSMatrix *effects_typeselection;
    IBOutlet NSPopUpButton *initInput;
    IBOutlet NSPopUpButton *initOutput;
    IBOutlet NSWindow *initWindow;
    IBOutlet NSMenu *openRecentMenu;
    IBOutlet NSMatrix *pedal_expressionpedal;
    IBOutlet NSButtonCell *pedal_fxlevel;
    IBOutlet NSMatrix *pedal_fxreverbbypass;
    IBOutlet NSMatrix *pedal_fxreverbbypassselection;
    IBOutlet NSButtonCell *pedal_fxval1;
    IBOutlet NSButtonCell *pedal_fxval2;
    IBOutlet NSButtonCell *pedal_fxval3;
    IBOutlet NSButtonCell *pedal_fxval4;
    IBOutlet NSMenuItem *receiveAll;
    IBOutlet NSStepper *reverb_diffusion;
    IBOutlet NSTextField *reverb_diffusionfield;
    IBOutlet NSStepper *reverb_in;
    IBOutlet NSTextField *reverb_infield;
    IBOutlet NSStepper *reverb_time;
    IBOutlet NSTextField *reverb_timefield;
    IBOutlet NSStepper *reverb_tone;
    IBOutlet NSTextField *reverb_tonefield;
    IBOutlet NSMatrix *reverb_typeselection;
    IBOutlet NSMenuItem *sendAll;
    IBOutlet NSSlider *traditional_bass;
    IBOutlet NSSlider *traditional_gain;
    IBOutlet NSSlider *traditional_master;
    IBOutlet NSSlider *traditional_middle;
    IBOutlet NSSlider *traditional_presence;
    IBOutlet NSSlider *traditional_reverb;
    IBOutlet NSSlider *traditional_treble;
    IBOutlet NSSlider *traditional_volume;
    IBOutlet NSButtonCell *vibroFastSlow;

    NSString *fileName;
    NSString *currentDirectory;
    bool interfaceModification;
    unsigned char fxleveltype;		// if val=0 -> value (1 to 10)
    unsigned char fxval1type;		// if val=1 -> time (30 to 1440)
    unsigned char fxval2type;		// if val=2 -> frequency (0.08 to 10)
    unsigned char fxval3type;		// if val=3 -> pedal wah (The baby's crying or the real Mc Q)
    unsigned char fxval4type;		// if val=4 -> touch wah (Low Q or High Q)
    MIDIClientRef	midiClient;
    MIDIPortRef		midiInPort, midiOutPort;
    MIDIEndpointRef 	currentMidiInEndpoint, currentMidiOutEndpoint;
    char	timeTable[256][4];
    char 	freqTable[256][4];
    char 	valueTable[256][4];
    char	*pedalWahTable[2];
    char	*touchWahTable[2];
}
- (void)readPreferences;
- (void)sendData:(unsigned char)function:(unsigned char)value;
- (void)openRecentManage:(NSString*)path;
- (void)awakeFromNib;
- (void)loadFile2;
- (void)loadFile3;
-(void)updateGUI:(int)midiCommand :(int)midiValue;
-(void)updateGUI:(Byte[])midiCommand ;

- (IBAction)autoReceiveSelection:(id)sender;
- (IBAction)autoSendSelection:(id)sender;
- (IBAction)displayFxFields:(id)sender;
- (IBAction)loadFile:(id)sender;
- (IBAction)midiInitialization:(id)sender;
- (IBAction)midiInitialization2:(id)sender;
- (IBAction)newFile:(id)sender;
- (IBAction)quit:(id)sender;
- (IBAction)receiveAllData:(id)sender;
- (IBAction)resetPresets:(id)sender;
- (IBAction)saveAsFile:(id)sender;
- (IBAction)saveFile:(id)sender;
- (IBAction)sendAllData:(id)sender;
- (IBAction)setAmpCompressorSelection:(id)sender;
- (IBAction)setAmpDriveCircuitry:(id)sender;
- (IBAction)setAmpNoiseGateThreshold:(id)sender;
- (IBAction)setAmpSpeakerPhaseSelection:(id)sender;
- (IBAction)setAmpTimbreSelection:(id)sender;
- (IBAction)setAmpToneStackPosition:(id)sender;
- (IBAction)setAmpToneStackType:(id)sender;
- (IBAction)setFieldDepth:(id)sender;
- (IBAction)setFieldFxLevel:(id)sender;
- (IBAction)setFieldFxVal1:(id)sender;
- (IBAction)setFieldFxVal2:(id)sender;
- (IBAction)setFieldFxVal3:(id)sender;
- (IBAction)setFieldFxVal4:(id)sender;
- (IBAction)setFieldReverbDiffusion:(id)sender;
- (IBAction)setFieldReverbIn:(id)sender;
- (IBAction)setFieldReverbTime:(id)sender;
- (IBAction)setFieldReverbTone:(id)sender;
- (IBAction)setPedalExpression:(id)sender;
- (IBAction)setPedalFXReverbByPass:(id)sender;
- (IBAction)setPedalFxReverbOnOff:(id)sender;
- (IBAction)setReverbTypeSelection:(id)sender;
- (IBAction)setTraditionalBass:(id)sender;
- (IBAction)setTraditionalGain:(id)sender;
- (IBAction)setTraditionalMaster:(id)sender;
- (IBAction)setTraditionalMiddle:(id)sender;
- (IBAction)setTraditionalPresence:(id)sender;
- (IBAction)setTraditionalReverb:(id)sender;
- (IBAction)setTraditionalTreble:(id)sender;
- (IBAction)setTraditionalVolume:(id)sender;
@end
