#import "CyberTwin.h"


int getbit(int column, int value)
{
unsigned char byteValue=value;

byteValue=byteValue<<(8-column);
byteValue=byteValue>>7;

return byteValue;
}

static void midi_read_proc (const MIDIPacketList* packets, void *refCon, void* connRefCon)
{
    int	i, j;
    const MIDIPacket*		packet;
    CyberTwin* ct = (CyberTwin*)refCon;
    
    // Step through each packet
    packet = packets->packet;
    for (i = 0; i < packets->numPackets; i++) {

        if (packet->data[0] == 176) {
            [ ct updateGUI :packet->data[1] :packet->data[2] ];
        }
        else
        if ( (packet->length == 55)
            && (packet->data[0] == 0xF0)  	//Exclusive message
            && (packet->data[1] == 0x08)	// Fender Id
            && (packet->data[2] == 0x21)	// Priphrique Omni
            && (packet->data[3] == 0x11)    	// CyberTwin id
            && (packet->data[4] == 0x02))	// Preset message
        {
            Byte midiData[packet->length];
        
            for (i=0;i<packet->length;i++)
            {
                midiData[i]=packet->data[i];
            }
			
			[ ct updateGUI : midiData ];
		}
        else
        for (j = 0; j < packet->length; j++) {
           // Nothing, just for testing 

        }
        
        packet = MIDIPacketNext (packet);
    }
    

}

@implementation CyberTwin

/******************************************************* 
   THIS PART IS RELATED TO THE INTERFACE ACTION METHODS
 *******************************************************/ 

- (bool)openRecent:(NSMenuItem*)path
{ 
    if (interfaceModification)
    {
        //We should test and ask if we must save before creating a new file.
        int status;
        status = NSRunAlertPanel(	NSLocalizedString(@"Attention", @"Description Forthcoming"), 
                                        NSLocalizedString(@"SaveModification", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Yes", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Cancel", @"Description Forthcoming"), 
                                        NSLocalizedString(@"No", @"Description Forthcoming")
                                );

        if ( status == NSAlertDefaultReturn )	// Button = Yes
        {
            [self saveFile:nil];
        }
        
        if (status!=NSAlertAlternateReturn)	// Button = Yes or No
        {
            if (fileName)
                [ fileName release ];
            fileName = [ [NSString alloc ] initWithString: [path representedObject] ];
            [ self loadFile3 ];
        }
    }
    else
    {
        if (fileName)
           [ fileName release ];
        fileName = [ [NSString alloc ] initWithString: [path representedObject] ];
        [ self loadFile3 ];
    }



return true;
}

// This method manage the OpenRecent menu
- (void)openRecentManage:(NSString*)path
{
 int numberOfItems = [ openRecentMenu numberOfItems ];

 int biggestTag = 0;
 
 int i;
 
 if (numberOfItems > 0)
 {
    for (i = 0; i < numberOfItems;i++)
    {
        NSMenuItem *current = [ openRecentMenu itemAtIndex: i ];
        if ( [ current tag ] > biggestTag)
            biggestTag = [ current tag ];
    }
 }
 
 if (![openRecentMenu itemWithTitle : [ comment stringValue]])
 {
    // In this case (more than 5 files) we must remove the oldest
    if (numberOfItems > 4)
    {
        int moreLittleTag = [ [ openRecentMenu itemAtIndex: 0 ] tag ];
        
        for (i = 1; i < numberOfItems;i++)
        {
            NSMenuItem *current = [ openRecentMenu itemAtIndex: i ];
            if ( [ current tag ] < biggestTag)
                biggestTag = [ current tag ];
        }
        
        [ openRecentMenu removeItem : [ openRecentMenu itemWithTag: moreLittleTag ] ];
    }
 
    NSMenuItem *newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:[comment stringValue] action:NULL keyEquivalent:@""];
    [newItem setTag:biggestTag +1];
    [newItem setTarget:self];
    [newItem setAction:@selector(openRecent:)];
    [newItem setRepresentedObject: (id)path ];
    [openRecentMenu addItem:newItem];
    [newItem release];
    
 }
 else
 {
    NSMenuItem *theItem = [ openRecentMenu itemWithTitle: [comment stringValue ] ];
    [ theItem setTag: biggestTag +1 ];
 }
 
}

//This method updates the GUI with input MIDI messages
-(void)updateGUI:(int)midiCommand :(int)midiValue
{
    if ([ autoReceive state ] == NSOnState)
    {
        if (midiCommand==102)
            [ traditional_gain setIntValue: midiValue ];
        if (midiCommand==103)
            [ traditional_volume setIntValue: midiValue ];
        if (midiCommand==104)
            [ traditional_treble setIntValue: midiValue ];
        if (midiCommand==105)
            [ traditional_middle setIntValue: midiValue ];
        if (midiCommand==106)
            [ traditional_bass setIntValue: midiValue ];
        if (midiCommand==107)
            [ traditional_presence setIntValue: midiValue ];
        if (midiCommand==108)
            [ traditional_reverb setIntValue: midiValue ];
        if (midiCommand==109)
            [ traditional_master setIntValue: midiValue ];
        if (midiCommand==110) {
                [ effects_fxlevel setIntValue: midiValue ];
                [ self setFieldFxLevel:nil ];
        }
        if (midiCommand==111) {
                [ effects_fxval1 setIntValue: midiValue ];
                [ self setFieldFxVal1:nil ];
        }
        if (midiCommand==112) {
                [ effects_fxval2 setIntValue: midiValue ];
                [ self setFieldFxVal2:nil ];
        }
        if (midiCommand==113) {
                [ effects_fxval3 setIntValue: midiValue ];
                [ self setFieldFxVal3:nil ];
        }
        if (midiCommand==114) {
                [ effects_fxval4 setIntValue: midiValue ];
                [ self setFieldFxVal4:nil ];
        }
        if (midiCommand==115) {
                [ reverb_in setIntValue: midiValue ];
                [ self setFieldReverbIn:nil ];
        }
        if (midiCommand==116) {
                [ reverb_tone setIntValue: midiValue ];
                [ self setFieldReverbTone:nil ];
        }
        if (midiCommand==117) {
                [ reverb_time setIntValue: midiValue ];
                [ self setFieldReverbTime:nil ];
        }
        if (midiCommand==118) {
                [ reverb_diffusion setIntValue: midiValue ];
                [ self setFieldReverbDiffusion:nil ];
        }
    }
}

-(void)updateGUI:(Byte[])midiCommand
{
// We got the name of the preset
int i;
int j=0;
char presetName[17];
for (i=9;i<=26;i++) 
{
    if (i!=16 && i!=24)
    { 	       
        presetName[j]=midiCommand[i];
        j++;
    }
}

[ comment setStringValue: [ NSString stringWithCString:presetName length:16 ] ];


// We got the other data
int ng;
int vol;
int gain;
int treble;        
int middle;        
int bass;        
int presence;        
int reverb;        
int dwell;        
int tone;        
int time;        
int diff;        
int fx1;        
int fx2;        
int fx3;        
int fx4;        
int fx5;
int speakerpolarity;
int timbreselection;
int reverbtype;
int tonetype;
int drive;
int toneposition;
int expressionpedal;
int compressor;
int noiseseuil;
int bypass; 
int fxtype;



ng=128*getbit(6,midiCommand[32])+midiCommand[34];
vol=midiCommand[35]+128*getbit(5,midiCommand[32]);
gain=midiCommand[36]+128*getbit(4,midiCommand[32]);
treble=midiCommand[37]+128*getbit(3,midiCommand[32]);        
middle=midiCommand[38]+128*getbit(2,midiCommand[32]);;        
bass=midiCommand[39]+128*getbit(1,midiCommand[32]);        
presence=midiCommand[41]+128*getbit(7,midiCommand[40]);        
reverb=midiCommand[42]+128*getbit(6,midiCommand[40]);         
dwell=midiCommand[43]+128*getbit(5,midiCommand[40]);         
tone=midiCommand[44]+128*getbit(4,midiCommand[40]);       
time=midiCommand[45]+128*getbit(3,midiCommand[40]); ;        
diff=midiCommand[46]+128*getbit(2,midiCommand[40]);         
fx1=midiCommand[47]+128*getbit(1,midiCommand[40]);         
fx2=midiCommand[49]+128*getbit(7,midiCommand[48]);         
fx3=midiCommand[50]+128*getbit(6,midiCommand[48]);        
fx4=midiCommand[51]+128*getbit(5,midiCommand[48]);        
fx5=midiCommand[52]+128*getbit(4,midiCommand[48]);

speakerpolarity=getbit(7,midiCommand[27])+2*getbit(5,midiCommand[24]);
timbreselection=getbit(4,midiCommand[24])+2*getbit(1,midiCommand[27])+4*getbit(2,midiCommand[27]);
reverbtype=getbit(3,midiCommand[27])+2*getbit(4,midiCommand[27])+4*getbit(5,midiCommand[27])+8*getbit(6,midiCommand[27]);
tonetype=getbit(1,midiCommand[28])+2*getbit(2,midiCommand[28]);
drive=getbit(3,midiCommand[28])+2*getbit(4,midiCommand[28])+4*getbit(5,midiCommand[28])+8*getbit(6,midiCommand[28]);
toneposition=getbit(7,midiCommand[28]);
expressionpedal=1*getbit(3,midiCommand[29])+2*getbit(4,midiCommand[29])+4*getbit(5,midiCommand[29])+8*getbit(6,midiCommand[29]);
compressor=getbit(1,midiCommand[30])+2*getbit(2,midiCommand[30])+4*getbit(3,midiCommand[30]);
noiseseuil=getbit(5,midiCommand[30])+2*getbit(6,midiCommand[30]);
bypass=getbit(1,midiCommand[31])+2*getbit(2,midiCommand[31])+4*getbit(3,midiCommand[31])+8*getbit(4,midiCommand[31]); 
fxtype=getbit(1,midiCommand[33])+2*getbit(2,midiCommand[33])+4*getbit(3,midiCommand[33])+8*getbit(4,midiCommand[33])+16*getbit(5,midiCommand[33]);

[ amp_noisegatedepthselection setIntValue: ng/2 ];
[ traditional_volume setIntValue: vol/2 ];
[ traditional_gain setIntValue: gain/2 ];
[ traditional_treble setIntValue: treble/2 ];        
[ traditional_middle setIntValue: middle/2 ];        
[ traditional_bass setIntValue: bass/2 ];        
[ traditional_presence setIntValue: presence/2 ];        
[ traditional_reverb setIntValue: reverb/2 ];        
[ reverb_in setIntValue: dwell/2 ];        
[ reverb_tone setIntValue: tone/2 ];        
[ reverb_time setIntValue: time/2 ];        
[ reverb_diffusion setIntValue: diff/2 ];        
[effects_fxlevel setIntValue: fx1/2 ];        
[effects_fxval1 setIntValue: fx2/2 ];        
[effects_fxval2 setIntValue: fx3/2 ];        
[effects_fxval3 setIntValue: fx4/2 ];        
[effects_fxval4 setIntValue: fx5/2 ];


[ amp_speakerphaseselection selectCellWithTag: speakerpolarity ];
[ amp_timbreselection selectCellWithTag: timbreselection ];
[ reverb_typeselection selectCellWithTag: reverbtype ];
[ amp_tonestacktype selectCellWithTag: tonetype ];
[ amp_drivecircuitry selectCellWithTag: drive ];
[ amp_tonestackposition selectCellWithTag: toneposition ];
[ pedal_expressionpedal selectCellWithTag: expressionpedal ];
[ amp_compressorselection selectCellWithTag: compressor ];
[ amp_noisegatethresholdselection selectCellWithTag: noiseseuil ];
[ pedal_fxreverbbypassselection selectCellWithTag: bypass ];
[ effects_typeselection selectCellWithTag: fxtype ];

// And update string fields
[ self displayFxFields:nil];
[ self setFieldDepth:nil];
[ self setFieldReverbDiffusion:nil];
[ self setFieldReverbIn:nil];
[ self setFieldReverbTime:nil];
[ self setFieldReverbTone:nil];


}

// This method reset all presets
- (IBAction)resetPresets:(id)sender
{
        if (fileName)
            [ fileName release ];
        [ comment setStringValue: @""];
        // We put default value for each preset
        [ traditional_gain 			setIntValue: 	   64 ];
        [ traditional_volume 			setIntValue: 	   64 ];
        [ traditional_treble 			setIntValue: 	   64 ];
        [ traditional_middle 			setIntValue: 	   64 ];
        [ traditional_bass 			setIntValue: 	   64 ];
        [ traditional_presence 			setIntValue: 	   64 ];
        [ traditional_reverb 			setIntValue: 	   64 ];
        [ traditional_master 			setIntValue: 	   64 ];
        [ amp_tonestacktype	 		selectCellWithTag: 0 ];
        [ amp_tonestackposition	 		selectCellWithTag: 0 ];
        [ amp_timbreselection	 		selectCellWithTag: 0 ];
        [ amp_speakerphaseselection 		selectCellWithTag: 0 ];
        [ amp_compressorselection 		selectCellWithTag: 0 ];
        [ amp_drivecircuitry	 		selectCellWithTag: 0 ];
        [ amp_noisegatethresholdselection	selectCellWithTag: 0 ];
        [ amp_noisegatedepthselection 		setIntValue: 	   0 ];
        [ reverb_in		 		setIntValue: 	   0 ];
        [ reverb_tone		 		setIntValue: 	   0 ];
        [ reverb_time		 		setIntValue: 	   0 ];
        [ reverb_diffusion	 		setIntValue: 	   0 ];
        [ reverb_typeselection			selectCellWithTag: 0 ];
        [ effects_typeselection			selectCellWithTag: 0 ];
        [ effects_fxlevel			setIntValue: 	   0 ];
        [ effects_fxval1			setIntValue: 	   0 ];
        [ effects_fxval2			setIntValue: 	   0 ];
        [ effects_fxval3			setIntValue: 	   0 ];
        [ effects_fxval4			setIntValue: 	   0 ];
        [ pedal_expressionpedal			selectCellWithTag: 0 ];
        [ pedal_fxreverbbypassselection		selectCellWithTag: 0 ];
        [ pedal_fxreverbbypass			selectCellWithTag: 0 ];
        
        // We hide some fields because None is selected
        [ pedal_fxreverbbypassselection setEnabled: false ];
        [ effects_fxlevel setEnabled: false ];
        [ effects_fxval1 setEnabled: false ];
        [ effects_fxval2 setEnabled: false ];
        [ effects_fxval3 setEnabled: false ];
        [ effects_fxval4 setEnabled: false ];
        
        // And update string fields
        [ self displayFxFields:sender];

        // And finally send everything to the Cybertwin
        [ self sendAllData: sender ];
        
        // And we reset the interfaceModification flag
        interfaceModification=false;
}

- (IBAction)setAmpCompressorSelection:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x07 :[[amp_compressorselection selectedCell]tag] ];
}

- (IBAction)setAmpDriveCircuitry:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x02 :[[amp_drivecircuitry selectedCell]tag] ];
}

- (IBAction)setAmpNoiseGateThreshold:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x09 :[[amp_noisegatethresholdselection selectedCell]tag] ];
}

- (IBAction)setAmpSpeakerPhaseSelection:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x06 :[[amp_speakerphaseselection selectedCell]tag] ];
}

- (IBAction)setAmpTimbreSelection:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x05 :[[amp_timbreselection selectedCell]tag] ];
}

- (IBAction)setAmpToneStackPosition:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x01 :[[amp_tonestackposition selectedCell]tag] ];
}

- (IBAction)setAmpToneStackType:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x00 :[[amp_tonestacktype selectedCell]tag] ];
}

- (IBAction)setPedalExpression:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x0A :[[pedal_expressionpedal selectedCell]tag] ];
}

- (IBAction)setPedalFXReverbByPass:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x0C :[[pedal_fxreverbbypassselection selectedCell]tag] ];
}

- (IBAction)setPedalFxReverbOnOff:(id)sender
{
    interfaceModification=true;

    if ([[pedal_fxreverbbypass selectedCell]tag]==0)
        [pedal_fxreverbbypassselection setEnabled: true];
    else
        [pedal_fxreverbbypassselection setEnabled: false];

    [ self sendData :85 :[[pedal_fxreverbbypass selectedCell]tag] ];
}

- (IBAction)setReverbTypeSelection:(id)sender
{
    interfaceModification=true;

//    [ self sendData :0x04 :[[reverb_typeselection selectedCell]tag] ];
}

- (IBAction)setTraditionalBass:(id)sender
{
    interfaceModification=true;

    [ self sendData :106 :[traditional_bass intValue ]];
}

- (IBAction)setTraditionalGain:(id)sender
{
    interfaceModification=true;

    [ self sendData :102 :[traditional_gain intValue ]];
}

- (IBAction)setTraditionalMaster:(id)sender
{
    interfaceModification=true;

    [ self sendData :109 :[traditional_master intValue ]];
}

- (IBAction)setTraditionalMiddle:(id)sender
{
    interfaceModification=true;

    [ self sendData :105 :[traditional_middle intValue ]];
}

- (IBAction)setTraditionalPresence:(id)sender
{
    interfaceModification=true;

    [ self sendData :107 :[traditional_presence intValue ]];
}

- (IBAction)setTraditionalReverb:(id)sender
{
    interfaceModification=true;

    [ self sendData :108 :[traditional_reverb intValue ]];
}

- (IBAction)setTraditionalTreble:(id)sender
{
    interfaceModification=true;

    [ self sendData :104 :[traditional_treble intValue ]];
}

- (IBAction)setTraditionalVolume:(id)sender
{
    interfaceModification=true;

    [ self sendData :103 :[traditional_volume intValue ]];
}


// This method display the name of Parameters Fields when an effect is selected.
// It stores informations such as min and max numbers.
- (IBAction)displayFxFields:(id)sender
{
NSButtonCell *selectedCell = [ effects_typeselection selectedCell ];
int tag = [ selectedCell tag ];

interfaceModification=true;

// if Vibratone is not selected, we can't see this
[ vibroFastSlow setTransparent: true ];

if (tag == 0)	// None is selected
{
    [ effects_textfxlevel setStringValue  : @"" ];
    [ effects_textfxval1 setStringValue  : @"" ];
    [ effects_textfxval2 setStringValue  : @"" ];
    [ effects_textfxval3 setStringValue  : @"" ];
    [ effects_textfxval4 setStringValue  : @"" ];
    [ effects_fieldfxlevel setStringValue  : @"" ];
    [ effects_fieldfxval1 setStringValue  : @"" ];
    [ effects_fieldfxval2 setStringValue  : @"" ];
    [ effects_fieldfxval3 setStringValue  : @"" ];
    [ effects_fieldfxval4 setStringValue  : @"" ];
    [ effects_fxlevel setEnabled: false ];
    [ effects_fxval1 setEnabled: false ];
    [ effects_fxval2 setEnabled: false ];
    [ effects_fxval3 setEnabled: false ];
    [ effects_fxval4 setEnabled: false ];
    [ pedal_fxlevel setTitle : @"Effects Level" ];
    [ pedal_fxval1 setTitle : @"Fx Value 1" ];
    [ pedal_fxval2 setTitle : @"Fx Value 2" ];
    [ pedal_fxval3 setTitle : @"Fx Value 3" ];
    [ pedal_fxval4 setTitle : @"Fx Value 4" ];
}
else
if (tag == 1) // Mono Delay is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Delay Out Level" ];
    [ pedal_fxlevel setTitle  : @"Delay Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Delay FeedBack" ];
    [ pedal_fxval2 setTitle  : @"Delay FeedBack" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Brightness" ];
    [ pedal_fxval3 setTitle  : @"Delay Brightness" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Delay In Level" ];
    [ pedal_fxval4 setTitle  : @"Delay In Level" ];
    fxval4type=0;
}
else
if  ( (tag == 2) ||  // Dotted 8/16 Delay is selected
      (tag == 3)  || // One-E-Da Delay is selected
      (tag == 4) ||   // Ping Pong Delay is selected
      (tag == 5) ||   // Swing Tap Delay is selected
      (tag == 8) )   // Stereo Flam Delay is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Delay Out Level" ];
    [ pedal_fxlevel setTitle  : @"Delay Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Delay FeedBack" ];
    [ pedal_fxval2 setTitle  : @"Delay FeedBack" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Brightness" ];
    [ pedal_fxval3 setTitle  : @"Delay Brightness" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Delay Stereo" ];
    [ pedal_fxval4 setTitle  : @"Delay Stereo" ];
    fxval4type=0;
}
else
if ( (tag == 6) || // Tape Echo is selected
     (tag == 7) ) // Stereo Tape Echo is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Echo Out Level" ];
    [ pedal_fxlevel setTitle  : @"Echo Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Echo Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Echo Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Echo FeedBack" ];
    [ pedal_fxval2 setTitle  : @"Echo FeedBack" ];
    fxval2type=0;    
    [ effects_textfxval3 setStringValue  : @"Wow & Flutter" ];
    [ pedal_fxval3 setTitle  : @"Wow & Flutter" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Echo Brightness" ];
    [ pedal_fxval4 setTitle  : @"Echo Brightness" ];
    fxval4type=0;
}
else
if  (tag == 9)  // Ducking Delay is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Delay Out Level" ];
    [ pedal_fxlevel setTitle  : @"Delay Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Delay FeedBack" ];
    [ pedal_fxval2 setTitle  : @"Delay FeedBack" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Release" ];
    [ pedal_fxval3 setTitle  : @"Delay Release" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Delay Ducking Threshold" ];
    [ pedal_fxval4 setTitle  : @"Delay Ducking Threshold" ];
    fxval4type=0;
}
else
if  (tag == 10)  // Backwards Delay is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Delay Out Level" ];
    [ pedal_fxlevel setTitle  : @"Delay Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Delay Forward FeedBack" ];
    [ pedal_fxval2 setTitle  : @"Delay Forward FeedBack" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Reverse FeedBack" ];
    [ pedal_fxval3 setTitle  : @"Delay Reverse FeedBack" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Delay Brightness" ];
    [ pedal_fxval4 setTitle  : @"Delay Brightness" ];
    fxval4type=0;
}
else
if  (tag == 11)  // Tremolo is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Tremolo Out Level" ];
    [ pedal_fxlevel setTitle  : @"Tremolo Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Tremolo Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Tremolo Rate (Hz)" ];    
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Tremolo Depth" ];
    [ pedal_fxval2 setTitle  : @"Tremolo Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Tremolo Offset" ];
    [ pedal_fxval3 setTitle  : @"Tremolo Offset" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Tremolo Shape" ];
    [ pedal_fxval4 setTitle  : @"Tremolo Shape" ];
    fxval4type=0;
}
else
if  (tag == 12)   // Amp Tremolo is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Tremolo Out Level" ];
    [ pedal_fxlevel setTitle  : @"Tremolo Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Tremolo Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Tremolo Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Tremolo Depth" ];
    [ pedal_fxval2 setTitle  : @"Tremolo Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Tremolo Dut Cycle" ];
    [ pedal_fxval3 setTitle  : @"Tremolo Dut Cycle" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Tremolo Shape" ];
    [ pedal_fxval4 setTitle  : @"Tremolo Shape" ];
    fxval4type=0;
}
else
if  (tag == 13)  // Auto Pan is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Pan Out Level" ];
    [ pedal_fxlevel setTitle  : @"Pan Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Pan Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Pan Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Pan Depth" ];
    [ pedal_fxval2 setTitle  : @"Pan Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Pan Shape" ];
    [ pedal_fxval3 setTitle  : @"Pan Shape" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Pan Phase" ];
    [ pedal_fxval4 setTitle  : @"Pan Phase" ];
    fxval4type=0;
}
else
if   (tag == 14)  // Phaser is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Phaser Out Level" ];
    [ pedal_fxlevel setTitle  : @"Phaser Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Phaser Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Phaser Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Phaser Depth" ];
    [ pedal_fxval2 setTitle  : @"Phaser Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Phaser Feedback" ];
    [ pedal_fxval3 setTitle  : @"Phaser Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Phaser Stereo" ];
    [ pedal_fxval4 setTitle  : @"Phaser Stereo" ];
    fxval4type=2;
}
else
if  (tag == 15)  // Vibratone is selected
{ 
    // When vibratone is selected, vibroFastSlow can be seen
    [ vibroFastSlow setTransparent: false ];

    [ effects_textfxlevel setStringValue  : @"Vibro Out Level" ];
    [ pedal_fxlevel setTitle  : @"Vibro Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Rotor Speed (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Rotor Speed (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Vibro Doppler" ];
    [ pedal_fxval2 setTitle  : @"Vibro Doppler" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Rotor 1 Freq. Speed 1 (Hz)" ];
    [ pedal_fxval3 setTitle  : @"Rotor 1 Freq. Speed 1 (Hz)" ];
    fxval3type=2;
    [ effects_textfxval4 setStringValue  : @"Rotor 2 Freq. Speed (Hz)" ];
    [ pedal_fxval4 setTitle  : @"Rotor 2 Freq. Speed (Hz)" ];
    fxval4type=2;
}
else
if  (tag == 16)  // Pedal Wah is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Wah Out Level" ];
    [ pedal_fxlevel setTitle  : @"Wah Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Wah" ];
    [ pedal_fxval1 setTitle  : @"Wah" ];
    fxval1type=0;
    [ effects_textfxval2 setStringValue  : @"Wah Heel Frequency" ];
    [ pedal_fxval2 setTitle  : @"Wah Heel Frequency" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Wah Toe Frequency" ];
    [ pedal_fxval3 setTitle  : @"Wah Toe Frequency" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Wah Sweep Type" ];
    [ pedal_fxval4 setTitle  : @"Wah Sweep Type" ];
    fxval4type=3;
}
else
if  (tag == 17)  // Touch Wah is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Wah Out Level" ];
    [ pedal_fxlevel setTitle  : @"Wah Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Wah Sensitivity" ];
    [ pedal_fxval1 setTitle  : @"Wah Sensitivity" ];
    fxval1type=0;
    [ effects_textfxval2 setStringValue  : @"Wah Minimum Frequency" ];
    [ pedal_fxval2 setTitle  : @"Wah Minimum Frequency" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Wah Maximum Frequency" ];
    [ pedal_fxval3 setTitle  : @"Wah Maximum Frequency" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Wah Sweep Type" ];
    [ pedal_fxval4 setTitle  : @"Wah Sweep Type" ];
    fxval4type=4;
}
else
if  (tag == 18)  // Sine Chorus is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Chorus Out Level" ];
    [ pedal_fxlevel setTitle  : @"Chorus Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Chorus Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Chorus Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Chorus Depth" ];
    [ pedal_fxval2 setTitle  : @"Chorus Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Chorus Average Delay" ];
    [ pedal_fxval3 setTitle  : @"Chorus Average Delay" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Sine Chorus Phase" ];
    [ pedal_fxval4 setTitle  : @"Sine Chorus Phase" ];
    fxval4type=0;
}
else
if  (tag == 19)  // Triangle Chorus is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Chorus Out Level" ];
    [ pedal_fxlevel setTitle  : @"Chorus Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Chorus Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Chorus Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Chorus Depth" ];
    [ pedal_fxval2 setTitle  : @"Chorus Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Chorus Average Delay" ];
    [ pedal_fxval3 setTitle  : @"Chorus Average Delay" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Tri-Chorus Phase" ];
    [ pedal_fxval4 setTitle  : @"Tri-Chorus Phase" ];
    fxval4type=0;
}
else
if  (tag == 20)  // Sine Flange is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Flange Out Level" ];
    [ pedal_fxlevel setTitle  : @"Flange Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Flange Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Flange Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Flange Depth" ];
    [ pedal_fxval2 setTitle  : @"Flange Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Flange Feedback" ];
    [ pedal_fxval3 setTitle  : @"Flange Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Sine Flange Phase" ];
    [ pedal_fxval4 setTitle  : @"Sine Flange Phase" ];
    fxval4type=0;
}
else
if  (tag == 21)  // Triangle Flange is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Flange Out Level" ];
    [ pedal_fxlevel setTitle  : @"Flange Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Flange Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Flange Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Flange Depth" ];
    [ pedal_fxval2 setTitle  : @"Flange Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Flange Feedback" ];
    [ pedal_fxval3 setTitle  : @"Flange Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Tri-Flange Phase" ];
    [ pedal_fxval4 setTitle  : @"Tri-Flange Phase" ];
    fxval4type=0;
}
else
if  (tag == 22)  // Delay + Chorus is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Chorus Depth" ];
    [ pedal_fxval2 setTitle  : @"Chorus Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Feedback" ];
    [ pedal_fxval3 setTitle  : @"Delay Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Chorus Rate (Hz)" ];
    [ pedal_fxval4 setTitle  : @"Chorus Rate (Hz)" ];
    fxval4type=2;
}
else
if  (tag == 23)  // Delay + Flange is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Flange Depth" ];
    [ pedal_fxval2 setTitle  : @"Flange Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Feedback" ];
    [ pedal_fxval3 setTitle  : @"Delay Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Flange Rate (Hz)" ];
    [ pedal_fxval4 setTitle  : @"Flange Rate (Hz)" ];
    fxval4type=2;
}
else
if  (tag == 24)  // Delay + Phaser is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Delay Time (ms)" ];
    [ pedal_fxval1 setTitle  : @"Delay Time (ms)" ];
    fxval1type=1;
    [ effects_textfxval2 setStringValue  : @"Phaser Depth" ];
    [ pedal_fxval2 setTitle  : @"Phaser Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Feedback" ];
    [ pedal_fxval3 setTitle  : @"Delay Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Phaser Rate (Hz)" ];
    [ pedal_fxval4 setTitle  : @"Phaser Rate (Hz)" ];
    fxval4type=2;
}
else
if  (tag == 25)  // AutoSwell + Chorus is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"AutoSwell Attack Time" ];
    [ pedal_fxval1 setTitle  : @"AutoSwell Attack Time" ];
    fxval1type=0;
    [ effects_textfxval2 setStringValue  : @"Chorus Depth" ];
    [ pedal_fxval2 setTitle  : @"Chorus Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"AutoSwell Sensitivity" ];
    [ pedal_fxval3 setTitle  : @"AutoSwell Sensitivity" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Chorus Rate (Hz)" ];
    [ pedal_fxval4 setTitle  : @"Chorus Rate (Hz)" ];
    fxval4type=2;
}
else
if  (tag == 26)  // UltraClean + Chorus is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Chorus Rate (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Chorus Rate (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Chorus Depth" ];
    [ pedal_fxval2 setTitle  : @"Chorus Depth" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Body" ];
    [ pedal_fxval3 setTitle  : @"Body" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Brilliance" ];
    [ pedal_fxval4 setTitle  : @"Brilliance" ];
    fxval4type=0;
}
else
if  (tag == 27)  // Pitch Shift is selected
{ 
    [ effects_textfxlevel setStringValue  : @"Pitch Shift Out Level" ];
    [ pedal_fxlevel setTitle  : @"Pitch Shift Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Pitch" ];
    [ pedal_fxval1 setTitle  : @"Pitch" ];
    fxval1type=0;
    [ effects_textfxval2 setStringValue  : @"Pitch Detune" ];
    [ pedal_fxval2 setTitle  : @"Pitch Detune" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Pitch Feedback" ];
    [ pedal_fxval3 setTitle  : @"Pitch Feedback" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Pitch PreDelay" ];
    [ pedal_fxval4 setTitle  : @"Pitch PreDelay" ];
    fxval4type=0;
}
else
if  (tag == 28)  // Ring Mod + Delay is selected
{ 
    [ effects_textfxlevel setStringValue  : @"FX Wet Out Level" ];
    [ pedal_fxlevel setTitle  : @"FX Wet Out Level" ];
    fxleveltype=0;
    [ effects_textfxval1 setStringValue  : @"Modulator Frequency (Hz)" ];
    [ pedal_fxval1 setTitle  : @"Modulator Frequency (Hz)" ];
    fxval1type=2;
    [ effects_textfxval2 setStringValue  : @"Delay Out Level" ];
    [ pedal_fxval2 setTitle  : @"Delay Out Level" ];
    fxval2type=0;
    [ effects_textfxval3 setStringValue  : @"Delay Time" ];
    [ pedal_fxval3 setTitle  : @"Delay Time" ];
    fxval3type=0;
    [ effects_textfxval4 setStringValue  : @"Delay Feedback" ];
    [ pedal_fxval4 setTitle  : @"Delay Feedback" ];
    fxval4type=0;
}

//    [ self sendData :0x03 :[[effects_typeselection selectedCell]tag] ];

// Now we fill TextField with the calculated Values if None is not selected (and we hide everything if it is)
    if (tag != 0)
    {
        [ effects_fxlevel setEnabled: true ];
        [ effects_fxval1 setEnabled: true ];
        [ effects_fxval2 setEnabled: true ];
        [ effects_fxval3 setEnabled: true ];
        [ effects_fxval4 setEnabled: true ];

		[ self setFieldFxLevel: nil ];
		[ self setFieldFxVal1: nil ];
		[ self setFieldFxVal2: nil ];
		[ self setFieldFxVal3: nil ];
		[ self setFieldFxVal4: nil ];
		
	}
   

}


// Set the Fx Level field value when the corresponding NSSlider is activated
- (IBAction)setFieldFxLevel:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;


    if (fxleveltype == 0) 
        [ effects_fieldfxlevel setStringValue: [NSString stringWithCString: valueTable[[ effects_fxlevel intValue ]*255/127] length:4] ];
    if (fxleveltype == 1) 
        [ effects_fieldfxlevel setStringValue: [NSString stringWithCString: timeTable[[ effects_fxlevel intValue ]*255/127] length:4] ];
    if (fxleveltype == 2) 
        [ effects_fieldfxlevel setStringValue: [NSString stringWithCString: freqTable[[ effects_fxlevel intValue ]*255/127] length:4] ];

    
    if (sender)
        [ self sendData :110 :[effects_fxlevel intValue] ];
}

// Set the FxVal1 field value when the corresponding NSSlider is activated
- (IBAction)setFieldFxVal1:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;


    if (fxval1type == 0) 
        [ effects_fieldfxval1 setStringValue: [NSString stringWithCString: valueTable[[ effects_fxval1 intValue ]*255/127] length:4] ];
    if (fxval1type == 1) 
        [ effects_fieldfxval1 setStringValue: [NSString stringWithCString: timeTable[[ effects_fxval1 intValue ]*255/127] length:4] ];
    if (fxval1type == 2) 
        [ effects_fieldfxval1 setStringValue: [NSString stringWithCString: freqTable[[ effects_fxval1 intValue ]*255/127] length:4] ];

    
    if (sender)
        [ self sendData :111 :[effects_fxval1 intValue] ];
}

// Set the FxVal2 field value when the corresponding NSSlider is activated
- (IBAction)setFieldFxVal2:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;


    if (fxval2type == 0) 
        [ effects_fieldfxval2 setStringValue: [NSString stringWithCString: valueTable[[ effects_fxval2 intValue ]*255/127] length:4] ];
    if (fxval2type == 1) 
        [ effects_fieldfxval2 setStringValue: [NSString stringWithCString: timeTable[[ effects_fxval2 intValue ]*255/127] length:4] ];
    if (fxval2type == 2) 
        [ effects_fieldfxval2 setStringValue: [NSString stringWithCString: freqTable[[ effects_fxval2 intValue ]*255/127] length:4] ];

    
    if (sender)
        [ self sendData :112 :[effects_fxval2 intValue] ];
}

// Set the FxVal3 field value when the corresponding NSSlider is activated
- (IBAction)setFieldFxVal3:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;


    if (fxval3type == 0) 
        [ effects_fieldfxval3 setStringValue: [NSString stringWithCString: valueTable[[ effects_fxval3 intValue ]*255/127] length:4] ];
    if (fxval3type == 1) 
        [ effects_fieldfxval3 setStringValue: [NSString stringWithCString: timeTable[[ effects_fxval3 intValue ]*255/127] length:4] ];
    if (fxval3type == 2) 
        [ effects_fieldfxval3 setStringValue: [NSString stringWithCString: freqTable[[ effects_fxval3 intValue ]*255/127] length:4] ];

    
    if (sender)
        [ self sendData :113 :[effects_fxval3 intValue] ];
}

// Set the FxVal4 field value when the corresponding NSSlider is activated
- (IBAction)setFieldFxVal4:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;


    if (fxval4type == 0) 
        [ effects_fieldfxval4 setStringValue: [NSString stringWithCString: valueTable[[ effects_fxval4 intValue ]*255/127] length:4] ];
    if (fxval4type == 1) 
        [ effects_fieldfxval4 setStringValue: [NSString stringWithCString: timeTable[[ effects_fxval4 intValue ]*255/127] length:4] ];
    if (fxval4type == 2) 
        [ effects_fieldfxval4 setStringValue: [NSString stringWithCString: freqTable[[ effects_fxval4 intValue ]*255/127] length:4] ];
    if (fxval4type == 3)
    {
        if ([ effects_fxval4 intValue ]==0)
            {
				[ effects_fieldfxval4 setStringValue: [NSString stringWithCString: pedalWahTable[0] ] ];

			}
        else
            {
				[ effects_fieldfxval4 setStringValue: [NSString stringWithCString: pedalWahTable[1] ] ];
				[ effects_fxval4 setIntValue: 1 ];
            }
    }
    if (fxval4type == 4)
    {
        if ([ effects_fxval4 intValue ]==0)
            {
				[ effects_fieldfxval4 setStringValue: [NSString stringWithCString: touchWahTable[0] ] ];
			}
        else
            {
				[ effects_fieldfxval4 setStringValue: [NSString stringWithCString: touchWahTable[1] ] ];
				[ effects_fxval4 setIntValue: 1 ];
            }
    }

    
    if (sender)
        [ self sendData :114 :[effects_fxval4 intValue] ];
}

// Set the Depth field value when the corresponding NSSlider is activated
- (IBAction)setFieldDepth:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;

    [ amp_noisegatedepthfield setStringValue: [NSString stringWithCString: valueTable[[ amp_noisegatedepthselection intValue ]*255/127] length:4] ];

//    [ self sendData :0x08 :[amp_noisegatedepthselection intValue] ];
}

// Set the Reverb diffusion field value when the corresponding NSSlider is activated
- (IBAction)setFieldReverbDiffusion:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;

    [ reverb_diffusionfield setStringValue: [NSString stringWithCString: valueTable[[ reverb_diffusion intValue ]*255/127] length:4] ];
 
    [ self sendData :118 :[reverb_diffusion intValue] ];
}

// Set the Reverb In field value when the corresponding NSSlider is activated
- (IBAction)setFieldReverbIn:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;

    [ reverb_infield setStringValue: [NSString stringWithCString: valueTable[[ reverb_in intValue ]*255/127] length:4] ];

    [ self sendData :115 :[reverb_in intValue] ];
}

// Set the Reverb time field value when the corresponding NSSlider is activated
- (IBAction)setFieldReverbTime:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;

    [ reverb_timefield setStringValue: [NSString stringWithCString: valueTable[[ reverb_time intValue ]*255/127] length:4] ];

    [ self sendData :117 :[reverb_time intValue] ];
}

// Set the Reverb tone field value when the corresponding NSSlider is activated
- (IBAction)setFieldReverbTone:(id)sender
{
// We receive data between 0  and 127 and it must be converted (for display)
// between 1 and 10.

    interfaceModification=true;

    [ reverb_tonefield setStringValue: [NSString stringWithCString: valueTable[[ reverb_tone intValue ]*255/127] length:4] ];

    [ self sendData :116 :[reverb_tone intValue] ];
}


/******************************************************* 
    THIS PART IS RELATED TO THE FILE OPEN/SAVE METHODS
 ******************************************************* 

    The file structure is this one: 
    the first byte is the length of the comment string (x)
    the next x bytes are the comment string
    the next 30 bytes are the preset in this order (between parenthesis is the gui object name):
                                                    gain (traditional_gain)
                                                    volume (traditional_volume)
                                                    treble (traditional_treble)
                                                    middle (traditional_middle)
			                            bass (traditional_bass)
			                            presence (traditional_presence)
			                            reverb (traditional_reverb)
			                            master (traditional_master)
			                            tonetype (amp_tonestacktype)
			                            toneposition (amp_tonestackposition)
			                            timbreselection (amp_timbreselection)
			                            speakerpolarity (amp_speakerphaseselection)
			                            compressor (amp_compressorselection)
			                            drive (amp_drivecircuitry)
			                            noiseseuil (amp_noisegatedepthselection)
			                            noisedepth (amp_noisegatethresholdselection)
			                            reverbin (reverb_in)
			                            reverbtone (reverb_tone)
			                            reverbtime(reverb_time)
			                            reverbdiff(reverb_diffusion)
			                            reverbtype (reverb_typeselection)
			                            fxtype (effects_typeselection)
			                            fxparam1 (effects_fxlevel)
			                            fxparam2 (effects_fxval1)
			                            fxparam3 (effects_fxval2)
			                            fxparam4 (effects_fxval3)
			                            fxparam5 (effects_fxval4)
			                            expressionpedal (pedal_expressionpedal)
			                            bypass (pedal_fxreverbbypassselection)
			                            pedalonoff (pedal_fxreverbbypass)
*/

- (IBAction)loadFile:(id)sender
{
    if (interfaceModification)
    {
        //We should test and ask if we must save before creating a new file.
        int status;

        status = NSRunAlertPanel(	NSLocalizedString(@"Attention", @"Description Forthcoming"), 
                                        NSLocalizedString(@"SaveModification", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Yes", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Cancel", @"Description Forthcoming"), 
                                        NSLocalizedString(@"No", @"Description Forthcoming")
                                );

        if ( status == NSAlertDefaultReturn )	// Button = Yes
        {
            [self saveFile:sender];
        }
        
        if (status!=NSAlertAlternateReturn)	// Button = Yes or No
        {
             [ self loadFile2 ];
        }
    }
    else
        [ self loadFile2 ];    
    
}

-(void)loadFile2
{
    int 	resultWindow;
    NSOpenPanel *oPanel = [NSOpenPanel openPanel];
    NSArray 	*fileType = [[NSArray init] arrayWithObject: @"cyt" ];

    [oPanel setAllowsMultipleSelection:NO];
    
    if (currentDirectory) // If wehave yet open a file, we use its directory as the default one
        resultWindow = [oPanel runModalForDirectory:currentDirectory file:nil  types:fileType ];
    else	// else we use the home directory
        resultWindow = [oPanel runModalForDirectory:NSHomeDirectory() file:nil  types:fileType ];
    
    if (resultWindow == NSOKButton) 
    {
        NSArray *filesToOpen = [oPanel filenames];
        if (fileName)
           [ fileName release ];
        fileName = [ [NSString alloc ] initWithString: [filesToOpen objectAtIndex:0] ];

        [ self loadFile3 ];

        // And we store the path of the file for future opening operations
        if (currentDirectory)
            [ currentDirectory release ];
        currentDirectory = [ [NSString alloc] initWithString: [ oPanel directory ] ];

    }
}


-(void)loadFile3
{
        // We read the file
        NSString *contentOfFile = [ NSString stringWithContentsOfFile: fileName ];
        
        // We get the comment
        if ([ [ comment stringValue ] length ] ==0) [ comment setStringValue: @" "];
        unichar commentLength = [contentOfFile characterAtIndex: 0];
		NSString *fileComment = [ [ contentOfFile substringFromIndex : 1 ] substringToIndex: commentLength ];
		[ comment setStringValue : fileComment ];
        
        // We read presets and change the GUI informations
        [ traditional_gain 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  1] ]; // gain (traditional_gain)
        [ traditional_volume 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  2] ]; // volume (traditional_volume)
        [ traditional_treble 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  3] ]; // treble (traditional_treble)
        [ traditional_middle 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  4] ]; // middle (traditional_middle)
        [ traditional_bass 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  5] ]; // bass (traditional_bass)
        [ traditional_presence 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  6] ]; // presence (traditional_presence)
        [ traditional_reverb 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  7] ]; // reverb (traditional_reverb)
        [ traditional_master 			setIntValue: 	   [contentOfFile characterAtIndex: commentLength +  8] ]; // master (traditional_master)
        [ amp_tonestacktype	 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength +  9] ]; // tonetype (amp_tonestacktype)
        [ amp_tonestackposition	 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 10] ]; // toneposition (amp_tonestackposition)
        [ amp_timbreselection	 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 11] ]; // timbreselection (amp_timbreselection)
        [ amp_speakerphaseselection 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 12] ]; // speakerpolarity (amp_speakerphaseselection)
        [ amp_compressorselection 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 13] ]; // compressor (amp_compressorselection)
        [ amp_drivecircuitry	 		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 14] ]; // drive (amp_drivecircuitry)
        [ amp_noisegatethresholdselection	selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 15] ]; // noiseseuil (amp_noisegatethresholdselection)
        [ amp_noisegatedepthselection 		setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 16] ]; // noisedepth (amp_noisegatedepthselection)
        [ reverb_in		 		setIntValue:  	   [contentOfFile characterAtIndex: commentLength + 17] ]; // reverbin (reverb_in)
        [ reverb_tone		 		setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 18] ]; // reverbtone (reverb_tone)
        [ reverb_time		 		setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 19] ]; // reverbtime(reverb_time)
        [ reverb_diffusion	 		setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 20] ]; // reverbdiff(reverb_diffusion)
        [ reverb_typeselection			selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 21] ]; // reverbtype (reverb_typeselection)
        [ effects_typeselection			selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 22] ]; // fxtype (effects_typeselection)
        [ effects_fxlevel			setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 23] ]; // fxparam1 (effects_fxlevel)
        [ effects_fxval1			setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 24] ]; // fxparam2 (effects_fxval1)
        [ effects_fxval2			setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 25] ]; // fxparam3 (effects_fxval2)
        [ effects_fxval3			setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 26] ]; // fxparam4 (effects_fxval3)
        [ effects_fxval4			setIntValue: 	   [contentOfFile characterAtIndex: commentLength + 27] ]; // fxparam5 (effects_fxval4)
        [ pedal_expressionpedal			selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 28] ]; // expressionpedal (pedal_expressionpedal)
        [ pedal_fxreverbbypassselection		selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 29] ]; //bypass (pedal_fxreverbbypassselection)
        [ pedal_fxreverbbypass			selectCellWithTag: [contentOfFile characterAtIndex: commentLength + 30] ]; //pedalonoff (pedal_fxreverbbypass)
        
        // And update string fields
        [ self displayFxFields:nil];
        [ self setFieldDepth:nil];
        [ self setFieldReverbDiffusion:nil];
        [ self setFieldReverbIn:nil];
        [ self setFieldReverbTime:nil];
        [ self setFieldReverbTone:nil];
        
        // We send all data to CT (if automatic sending is set)
        if ([ autoSend state ] == NSOnState)
            [ self sendAllData: nil ];
        
        // And we add the file to the OpenRecent Menu
        [ self openRecentManage: fileName ];

        
        interfaceModification = false;

}


- (IBAction)newFile:(id)sender
{
    if (interfaceModification)
    {
        //We should test and ask if we must save before creating a new file.
        int status;

        status = NSRunAlertPanel(	NSLocalizedString(@"Attention", @"Description Forthcoming"), 
                                        NSLocalizedString(@"SaveModification", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Yes", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Cancel", @"Description Forthcoming"), 
                                        NSLocalizedString(@"No", @"Description Forthcoming")
                                );

        if ( status == NSAlertDefaultReturn )	// Button = Yes
        {
            [self saveFile:sender];

        }

        if (status!=NSAlertAlternateReturn)	// Button = Yes Or No
        {
            [ self resetPresets: sender ];
        }
    }
    else
        [ self resetPresets: sender ];    
}

- (IBAction)saveAsFile:(id)sender
{
    int 	resultWindow;
    NSSavePanel *sPanel = [NSSavePanel savePanel];
    [ sPanel setRequiredFileType:@"cyt"];
    [ sPanel setDirectory: currentDirectory ];

    resultWindow = [sPanel runModalForDirectory:NSHomeDirectory()  file:nil ];
    
    if (resultWindow == NSOKButton) 
    {
        if (fileName)
           [ fileName release ];
        fileName = [ [NSString alloc ] initWithString: [sPanel filename]];
        
        [ self saveFile:sender];
    }

        // And we store the path of the file for future opening operations
        if (currentDirectory)
            [ currentDirectory release ];
        currentDirectory = [ [NSString alloc] initWithString: [ sPanel directory ] ];


}

- (IBAction)saveFile:(id)sender
{
    // If there is no filename, it is equivalent to a SaveAs command
    if (!fileName)
    {
            [self saveAsFile:sender];
    }
    
    // We do the test once again, to know if a cancel was not pressed when choosing a file name
     if (fileName)
    {
		NSFileManager *fileHandle;
//		NSFileHandle *fileHandle;
		NSData *fileData;
		char cData[1000];
		int count = 0;
	
		fileHandle = [ NSFileManager defaultManager ];
//		fileHandle = [ NSFileHandle fileHandleForWritingAtPath: fileName ];
	
				
            unsigned char sizeOfComment = [ [ comment stringValue ] length ];
            const char*cStringComment = [ [ comment stringValue ] cString ];
            
			//First we put the length of the comment
            cData[0]=sizeOfComment;
            // then the comment
            memcpy(&cData[1], cStringComment, sizeOfComment);
			count=sizeOfComment+1;
            // And the presets
            unsigned char presetValue;
            presetValue =   [ traditional_gain			intValue ]; // gain (traditional_gain)
            cData[count++]=presetValue;                
            presetValue =   [ traditional_volume 		intValue ]; // volume (traditional_volume)
            cData[count++]=presetValue;
            presetValue =   [ traditional_treble 		intValue ]; // treble (traditional_treble)
            cData[count++]=presetValue;
            presetValue =   [ traditional_middle 		intValue ]; // middle (traditional_middle)
            cData[count++]=presetValue;
            presetValue =   [ traditional_bass 			intValue ]; // bass (traditional_bass)
            cData[count++]=presetValue;
            presetValue =   [ traditional_presence 		intValue ]; // presence (traditional_presence)
            cData[count++]=presetValue;
            presetValue =   [ traditional_reverb 		intValue ]; // reverb (traditional_reverb)
            cData[count++]=presetValue;
            presetValue =   [ traditional_master 		intValue ]; // master (traditional_master)
            cData[count++]=presetValue;
            presetValue = [ [ amp_tonestacktype	 		selectedCell ] tag ]; // tonetype (amp_tonestacktype)
            cData[count++]=presetValue;
            presetValue = [ [ amp_tonestackposition	 	selectedCell ] tag ]; // toneposition (amp_tonestackposition)
            cData[count++]=presetValue;
            presetValue = [ [ amp_timbreselection	 	selectedCell ] tag ]; // timbreselection (amp_timbreselection)
            cData[count++]=presetValue;
            presetValue = [ [ amp_speakerphaseselection 	selectedCell ] tag ]; // speakerpolarity (amp_speakerphaseselection)
            cData[count++]=presetValue;
            presetValue = [ [ amp_compressorselection 		selectedCell ] tag ]; // compressor (amp_compressorselection)
            cData[count++]=presetValue;
            presetValue = [ [ amp_drivecircuitry	 	selectedCell ] tag ]; // drive (amp_drivecircuitry)
            cData[count++]=presetValue;
            presetValue = [ [ amp_noisegatethresholdselection	selectedCell ] tag ]; // noiseseuil (amp_noisegatethresholdselection)
            cData[count++]=presetValue;
            presetValue =   [ amp_noisegatedepthselection 	intValue ]; // noisedepth (amp_noisegatedepthselection)
            cData[count++]=presetValue;
            presetValue =   [ reverb_in		 		intValue ]; // reverbin (reverb_in)
            cData[count++]=presetValue;
            presetValue =   [ reverb_tone	 		intValue ]; // reverbtone (reverb_tone)
            cData[count++]=presetValue;
            presetValue =   [ reverb_time	 		intValue ]; // reverbtime(reverb_time)
            cData[count++]=presetValue;
            presetValue =   [ reverb_diffusion	 		intValue ]; // reverbdiff(reverb_diffusion)
            cData[count++]=presetValue;
            presetValue = [ [ reverb_typeselection		selectedCell ] tag ]; // reverbtype (reverb_typeselection)
            cData[count++]=presetValue;
            presetValue = [ [ effects_typeselection		selectedCell ] tag ]; // fxtype (effects_typeselection)
            cData[count++]=presetValue;
            presetValue =   [ effects_fxlevel			intValue ]; // fxparam1 (effects_fxlevel)
            cData[count++]=presetValue;
            presetValue =   [ effects_fxval1			intValue ]; // fxparam2 (effects_fxval1)
            cData[count++]=presetValue;
            presetValue =   [ effects_fxval2			intValue ]; // fxparam3 (effects_fxval2)
            cData[count++]=presetValue;
            presetValue =   [ effects_fxval3			intValue ]; // fxparam4 (effects_fxval3)
            cData[count++]=presetValue;
            presetValue =   [ effects_fxval4			intValue ]; // fxparam5 (effects_fxval4)
            cData[count++]=presetValue;
            presetValue = [ [ pedal_expressionpedal		selectedCell ] tag ]; // expressionpedal (pedal_expressionpedal)
            cData[count++]=presetValue;
            presetValue = [ [ pedal_fxreverbbypassselection	selectedCell ] tag ]; //bypass (pedal_fxreverbbypassselection)
            cData[count++]=presetValue;
            presetValue = [ [ pedal_fxreverbbypass		selectedCell ] tag ]; //pedalonoff (pedal_fxreverbbypass)
            cData[count++]=presetValue;

	
		fileData = [ NSData dataWithBytes: cData length: 1000 ];
		
//		[ fileHandle writeData: fileData ];

		[ fileHandle createFileAtPath:fileName contents:fileData attributes:nil ];
		
/* Replaced with Objective C code because of Special Characters in Filename (, , ....)
            FILE *fp;
            
            const char*cStringFileName = [ fileName cString ];
            unsigned char sizeOfComment = [ [ comment stringValue ] length ];
            const char*cStringComment = [ [ comment stringValue ] cString ];
            
            fp = fopen(cStringFileName,"w");
            
            //First we put the length of the comment
            fputc(sizeOfComment, fp);
            // then the comment
            fputs(cStringComment, fp);
            // And the presets
            unsigned char presetValue;
            presetValue =   [ traditional_gain			intValue ]; // gain (traditional_gain)
            fputc(presetValue, fp);                
            presetValue =   [ traditional_volume 		intValue ]; // volume (traditional_volume)
            fputc(presetValue, fp);
            presetValue =   [ traditional_treble 		intValue ]; // treble (traditional_treble)
            fputc(presetValue, fp);
            presetValue =   [ traditional_middle 		intValue ]; // middle (traditional_middle)
            fputc(presetValue, fp);
            presetValue =   [ traditional_bass 			intValue ]; // bass (traditional_bass)
            fputc(presetValue, fp);
            presetValue =   [ traditional_presence 		intValue ]; // presence (traditional_presence)
            fputc(presetValue, fp);
            presetValue =   [ traditional_reverb 		intValue ]; // reverb (traditional_reverb)
            fputc(presetValue, fp);
            presetValue =   [ traditional_master 		intValue ]; // master (traditional_master)
            fputc(presetValue, fp);
            presetValue = [ [ amp_tonestacktype	 		selectedCell ] tag ]; // tonetype (amp_tonestacktype)
            fputc(presetValue, fp);
            presetValue = [ [ amp_tonestackposition	 	selectedCell ] tag ]; // toneposition (amp_tonestackposition)
            fputc(presetValue, fp);
            presetValue = [ [ amp_timbreselection	 	selectedCell ] tag ]; // timbreselection (amp_timbreselection)
            fputc(presetValue, fp);
            presetValue = [ [ amp_speakerphaseselection 	selectedCell ] tag ]; // speakerpolarity (amp_speakerphaseselection)
            fputc(presetValue, fp);
            presetValue = [ [ amp_compressorselection 		selectedCell ] tag ]; // compressor (amp_compressorselection)
            fputc(presetValue, fp);
            presetValue = [ [ amp_drivecircuitry	 	selectedCell ] tag ]; // drive (amp_drivecircuitry)
            fputc(presetValue, fp);
            presetValue = [ [ amp_noisegatethresholdselection	selectedCell ] tag ]; // noiseseuil (amp_noisegatethresholdselection)
            fputc(presetValue, fp);
            presetValue =   [ amp_noisegatedepthselection 	intValue ]; // noisedepth (amp_noisegatedepthselection)
            fputc(presetValue, fp);
            presetValue =   [ reverb_in		 		intValue ]; // reverbin (reverb_in)
            fputc(presetValue, fp);
            presetValue =   [ reverb_tone	 		intValue ]; // reverbtone (reverb_tone)
            fputc(presetValue, fp);
            presetValue =   [ reverb_time	 		intValue ]; // reverbtime(reverb_time)
            fputc(presetValue, fp);
            presetValue =   [ reverb_diffusion	 		intValue ]; // reverbdiff(reverb_diffusion)
            fputc(presetValue, fp);
            presetValue = [ [ reverb_typeselection		selectedCell ] tag ]; // reverbtype (reverb_typeselection)
            fputc(presetValue, fp);
            presetValue = [ [ effects_typeselection		selectedCell ] tag ]; // fxtype (effects_typeselection)
            fputc(presetValue, fp);
            presetValue =   [ effects_fxlevel			intValue ]; // fxparam1 (effects_fxlevel)
            fputc(presetValue, fp);
            presetValue =   [ effects_fxval1			intValue ]; // fxparam2 (effects_fxval1)
            fputc(presetValue, fp);
            presetValue =   [ effects_fxval2			intValue ]; // fxparam3 (effects_fxval2)
            fputc(presetValue, fp);
            presetValue =   [ effects_fxval3			intValue ]; // fxparam4 (effects_fxval3)
            fputc(presetValue, fp);
            presetValue =   [ effects_fxval4			intValue ]; // fxparam5 (effects_fxval4)
            fputc(presetValue, fp);
            presetValue = [ [ pedal_expressionpedal		selectedCell ] tag ]; // expressionpedal (pedal_expressionpedal)
            fputc(presetValue, fp);
            presetValue = [ [ pedal_fxreverbbypassselection	selectedCell ] tag ]; //bypass (pedal_fxreverbbypassselection)
            fputc(presetValue, fp);
            presetValue = [ [ pedal_fxreverbbypass		selectedCell ] tag ]; //pedalonoff (pedal_fxreverbbypass)
            fputc(presetValue, fp);
            
            fclose(fp);

*/        
                    
        // And we add the file to the OpenRecent Menu
        [ self openRecentManage: fileName ];
                    
    }   
}

/******************************************************* 
  THIS PART IS RELATED TO THE MIDI SEND/RECEIVE METHODS
 *******************************************************/

- (IBAction)autoReceiveSelection:(id)sender
{
    if ([ autoReceive state ] == NSOffState)
        [ autoReceive setState: NSOnState ];
    else
        [ autoReceive setState: NSOffState ];
}

- (IBAction)autoSendSelection:(id)sender
{
    if ([ autoSend state ] == NSOffState)
        [ autoSend setState: NSOnState ];
    else
        [ autoSend setState: NSOffState ];
}

- (IBAction)midiInitialization:(id)sender
{
// If there's no MIDI devices, we ask the user if he wants to work online/offline
        if (MIDIGetNumberOfDevices()>0)
        {
            int numInputs = MIDIGetNumberOfSources();
            int numOutputs = MIDIGetNumberOfDestinations();
         
            if (numInputs > 1 || numOutputs > 1)
            {
                int i;

                [ initInput removeAllItems ];
                [ initOutput removeAllItems ];

                for (i=0;i<numInputs;i++)
                {
                    CFStringRef deviceName;
                    MIDIEndpointRef endpoint = MIDIGetSource(i);
                    MIDIObjectGetStringProperty(endpoint, kMIDIPropertyName, &deviceName);
                    [ initInput addItemWithTitle: (NSString*)deviceName ];
                }
                for (i=0;i<numOutputs;i++)
                {
                    CFStringRef deviceName;
                    MIDIEndpointRef endpoint = MIDIGetDestination(i);
                    MIDIObjectGetStringProperty(endpoint, kMIDIPropertyName, &deviceName);
                    [ initOutput addItemWithTitle: (NSString*)deviceName ];
                }
                [ initWindow makeKeyAndOrderFront: self ];

            }
            else 
            {
                [ self midiInitialization2: nil ];
            }

                [ sendAll setEnabled: true ];
                [ receiveAll setEnabled: true ];

        }
        else
        {
            int status;

            status = NSRunAlertPanel(	NSLocalizedString(@"Attention", @"Description Forthcoming"), 
                                        NSLocalizedString(@"ConnectionFailure", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Connected", @"Description Forthcoming"), 
                                        NSLocalizedString(@"Disconnected", @"Description Forthcoming"), 
                                        nil
                                );

            if ( status == NSAlertDefaultReturn )	// Button = Connected
            {
                [self midiInitialization:nil];
            }
            else
            {
                [ sendAll setEnabled: false ];
                [ receiveAll setEnabled: false ];
            }
        }
}

- (IBAction)midiInitialization2:(id)sender
{
    int inputPort = 0;
    int outputPort = 0;

    if (sender)
    {
        [ initWindow performClose: self ];
        inputPort = [ initInput indexOfSelectedItem ];
        outputPort = [ initOutput indexOfSelectedItem ];
    }
        
// We open midi port
            MIDIClientCreate (CFSTR ("CyberTwinIn"), NULL, NULL, &midiClient);

// We open midi input port
            MIDIInputPortCreate(midiClient, CFSTR ("InputPort"), midi_read_proc, (void*)self, &midiInPort);
            currentMidiInEndpoint = MIDIGetSource (inputPort);
            MIDIPortConnectSource (midiInPort, currentMidiInEndpoint, NULL);
  
// We open midi output port
            MIDIOutputPortCreate(midiClient, CFSTR ("OutputPort"), &midiOutPort);
            currentMidiOutEndpoint = MIDIGetDestination (outputPort);
            MIDIPortConnectSource (midiOutPort, currentMidiOutEndpoint, NULL);

// If AutoReceive is selected, we ask for all data
            if ([ autoReceive state ] == NSOnState)
                [ self receiveAllData: nil ];

}

- (void)sendData:(unsigned char)function:(unsigned char)value
{
    if ([ autoSend state ] == NSOnState)
    {
        Byte buffer[1024];
        MIDIPacketList *pktlist = (MIDIPacketList*)buffer;
        MIDIPacket *curPacket=MIDIPacketListInit(pktlist);
        Byte noteOn[] = { 176, function, value };
        curPacket = MIDIPacketListAdd(pktlist, sizeof(buffer), curPacket, 0, 3, noteOn);

        MIDISend(midiOutPort, currentMidiOutEndpoint, pktlist);

    }
}

// Send all data to the Cybertwin for example when initializing (at startup or when new file is activated) or when a file is loaded 
// ATTENTION: there is a bug in the Cybertwin: Expression Pedal and Continuous Controller can received 17 choices, but when it is sent 
// to the CyberTwin, it is coded with 4 bits (16 choices). The last one can't be selected
- (IBAction)sendAllData:(id)sender
{
unsigned char temp;
int i,k;
int ng = 2 * [ amp_noisegatedepthselection intValue ];
int vol = 2 * [ traditional_volume intValue ];
int gain = 2 * [ traditional_gain intValue ];
int treble = 2 * [ traditional_treble intValue ];        
int middle = 2 * [ traditional_middle intValue ];        
int bass = 2 * [ traditional_bass intValue ];        
int presence = 2 * [ traditional_presence intValue ];        
int reverb = 2 * [ traditional_reverb intValue ];        
int dwell = 2 * [ reverb_in intValue ];        
int tone = 2 * [ reverb_tone intValue ];        
int time = 2 * [ reverb_time intValue ];        
int diff = 2 * [ reverb_diffusion intValue ];        
int fx1 = 2 * [effects_fxlevel intValue];        
int fx2 = 2 * [effects_fxval1 intValue];        
int fx3 = 2 * [effects_fxval2 intValue];        
int fx4 = 2 * [effects_fxval3 intValue];        
int fx5 = 2 * [effects_fxval4 intValue];


int speakerpolarity=[ [ amp_speakerphaseselection selectedCell ] tag ];
int timbreselection=[ [ amp_timbreselection selectedCell ] tag ];
int reverbtype=[ [ reverb_typeselection selectedCell ] tag ];
int tonetype=[ [ amp_tonestacktype selectedCell ] tag ];
int drive=[ [ amp_drivecircuitry selectedCell ] tag ];
int toneposition=[ [ amp_tonestackposition selectedCell ] tag ];
int expressionpedal=[ [ pedal_expressionpedal selectedCell ] tag ];
int compressor=[ [ amp_compressorselection selectedCell ] tag ];
int noiseseuil=[ [ amp_noisegatethresholdselection selectedCell ] tag ];
int bypass=0; 
if ([ [ pedal_fxreverbbypass selectedCell ] tag ]==0)
    bypass= [ [ pedal_fxreverbbypassselection selectedCell ] tag ];  
int fxtype=[ [ effects_typeselection selectedCell ] tag ];




char fileComment[20]="                   ";
const char *tempComment = [ [ comment stringValue ] lossyCString ];

if ([ [ comment stringValue ] length ] > 0)
for (i = 0; i< [ [ comment stringValue] length ] && i<20;i++)
  fileComment[i] = tempComment[i];


int compt;

//algorithme de codage de fichiers au format CyberTwin
Byte tab[68];
//system exclusive header
tab[0]=0xF0;
tab[1]=0x08;
tab[2]=0x21;
tab[3]=0x11;
tab[4]=0x02;
tab[5]=0xF7;
//system exclusive data packet
tab[6]=0xF0;
tab[7]=0x08;
tab[8]=0x21;
tab[9]=0x11;
tab[10]=0x02;
tab[11]=0x00;//packet number
tab[12]=0x30;//(BYTE)numero;//MSB preset
tab[13]=0x02;//LSB preset
tab[14]=0x00;//*****************bits for subsequent bytes
//nom du fichier
tab[15]=(unsigned char)fileComment[0];
tab[16]=(unsigned char)fileComment[1];
tab[17]=(unsigned char)fileComment[2];
tab[18]=(unsigned char)fileComment[3];
tab[19]=(unsigned char)fileComment[4];
tab[20]=(unsigned char)fileComment[5];
tab[21]=(unsigned char)fileComment[6];
tab[22]=0x00;//******************bits for subsequent bytes
tab[23]=(unsigned char)fileComment[7];
tab[24]=(unsigned char)fileComment[8];
tab[25]=(unsigned char)fileComment[9];
tab[26]=(unsigned char)fileComment[10];
tab[27]=(unsigned char)fileComment[11];
tab[28]=(unsigned char)fileComment[12];
tab[29]=(unsigned char)fileComment[13];
tab[30]=(unsigned char)(64*0+32*0+16*getbit(2,speakerpolarity)+8*getbit(1,timbreselection)+4*1+2*1+1); //*****************bits for subsequent bytes
tab[31]=(unsigned char)fileComment[14];
tab[32]=(unsigned char)fileComment[15];
//fin du nom du fichier
//debut des donnees compressees.
tab[33]=(unsigned char)(getbit(2,timbreselection)+2*getbit(3,timbreselection)+4*getbit(1,reverbtype)+8*getbit(2,reverbtype)+16*getbit(3,reverbtype)+32*getbit(4,reverbtype)+64*getbit(1,speakerpolarity));
tab[34]=(unsigned char)(getbit(1,tonetype)+2*getbit(2,tonetype)+4*getbit(1,drive)+8*getbit(2,drive)+16*getbit(3,drive)+32*getbit(4,drive)+64*toneposition);//c'etait e2_prom1
tab[35]=(unsigned char)(1+0*2+4*getbit(1,expressionpedal)+8*getbit(2,expressionpedal)+16*getbit(3,expressionpedal)+32*getbit(4,expressionpedal));
tab[36]=(unsigned char)(getbit(1,compressor)+2*getbit(2,compressor)+4*getbit(3,compressor)+8+16*getbit(1,noiseseuil)+32*getbit(2,noiseseuil)+64);//c'etait e2_prom2
tab[37]=(unsigned char)(bypass+16+32+64);//msb eprom3
tab[38]=(unsigned char)(64*0+32*getbit(8,ng)+16*getbit(8,vol)+8*getbit(8,gain)+4*getbit(8,treble)+2*getbit(8,middle)+getbit(8,bass));//**************bits for subsequent bytes
tab[39]=(unsigned char)(fxtype);//lsb eprom3
//on fait les controlleurs permanents
tab[40]=(unsigned char)(ng-128*getbit(8,ng));//noise gate
tab[41]=(unsigned char)(vol-128*getbit(8,vol));//volume
tab[42]=(unsigned char)(gain-128*getbit(8,gain));//gain
tab[43]=(unsigned char)(treble-128*getbit(8,treble));//treble
tab[44]=(unsigned char)(middle-128*getbit(8,middle));//middle
tab[45]=(unsigned char)(bass-128*getbit(8,bass));//bass
tab[46]=(unsigned char)(64*getbit(8,presence)+32*getbit(8,reverb)+16*getbit(8,dwell)+8*getbit(8,tone)+4*getbit(8,time)+2*getbit(8,diff)+getbit(8,fx1));//**************bites for subsequent bytes
tab[47]=(unsigned char)(presence-128*getbit(8,presence));//presence
tab[48]=(unsigned char)(reverb-128*getbit(8,reverb));//reverb
tab[49]=(unsigned char)(dwell-128*getbit(8,dwell));//reverb in
tab[50]=(unsigned char)(tone-128*getbit(8,tone));//reverb tone
tab[51]=(unsigned char)(time-128*getbit(8,time));//reverb time
tab[52]=(unsigned char)(diff-128*getbit(8,diff));//reverb diff
tab[53]=(unsigned char)(fx1-128*getbit(8,fx1));//fx level
tab[54]=(unsigned char)(64*getbit(8,fx2)+32*getbit(8,fx3)+16*getbit(8,fx4)+8*getbit(8,fx5));//*******************bits for subsequent bytes
tab[55]=(unsigned char)(fx2-128*getbit(8,fx2));//fx val1
tab[56]=(unsigned char)(fx3-128*getbit(8,fx3));//fx val2
tab[57]=(unsigned char)(fx4-128*getbit(8,fx4));//fx val3
tab[58]=(unsigned char)(fx5-128*getbit(8,fx5));//fx val4

// test des caracterees.. a faire avant le checksum!!!
for(compt=15;compt<=21;compt++)
{
if(tab[compt]>122)tab[compt]=64;
if(tab[compt]<32) tab[compt]=64;
if(tab[compt]==91) tab[compt]=64;
if(tab[compt]==92) tab[compt]=64;
if(tab[compt]==93) tab[compt]=64;
if(tab[compt]==94) tab[compt]=64;
if(tab[compt]==95) tab[compt]=64;
if(tab[compt]==96) tab[compt]=64;
}
for(compt=23;compt<=29;compt++)
{
if(tab[compt]>122)tab[compt]=64;
if(tab[compt]<32) tab[compt]=64;
if(tab[compt]==91) tab[compt]=64;
if(tab[compt]==92) tab[compt]=64;
if(tab[compt]==93) tab[compt]=64;
if(tab[compt]==94) tab[compt]=64;
if(tab[compt]==95) tab[compt]=64;
if(tab[compt]==96) tab[compt]=64;
}
for(compt=31;compt<=32;compt++)
{
if(tab[compt]>122)tab[compt]=64;
if(tab[compt]<32) tab[compt]=64;
if(tab[compt]==91) tab[compt]=64;
if(tab[compt]==92) tab[compt]=64;
if(tab[compt]==93) tab[compt]=64;
if(tab[compt]==94) tab[compt]=64;
if(tab[compt]==95) tab[compt]=64;
if(tab[compt]==96) tab[compt]=64;
}
//fin des test de caracteres!!!!!

//*************calcul du checksum************
temp=tab[7]^tab[8];
for(k=9;k<=58;k++)
{
temp=temp^tab[k]; //ou exclusif
}

//***********end calculating checksum************
tab[59]=temp;//*******checksum******
tab[60]=0xF7;//end of sysex
//sysex end of file message
tab[61]=0xF0;
tab[62]=0x08;
tab[63]=0x21;
tab[64]=0x11;
tab[65]=0x02;
tab[66]=0x7B;
tab[67]=0xF7;


// Sending message
Byte buffer[1024];
MIDIPacketList *pktlist = (MIDIPacketList*)buffer;
MIDIPacket *curPacket=MIDIPacketListInit(pktlist);

curPacket = MIDIPacketListAdd(pktlist, sizeof(buffer), curPacket, 0, 68, tab);
MIDISend(midiOutPort, currentMidiOutEndpoint, pktlist);

}

- (IBAction)receiveAllData:(id)sender
{
        Byte buffer[1024];
        MIDIPacketList *pktlist = (MIDIPacketList*)buffer;
        MIDIPacket *curPacket=MIDIPacketListInit(pktlist);
        Byte noteOn[] = { 0xF0, 0x08, 0x00, 0x11, 0x04, 0x22, 0x00, 0x00, 0x00, 0x02, 0x7B, 0xF7 };
        curPacket = MIDIPacketListAdd(pktlist, sizeof(buffer), curPacket, 0, 12, noteOn);

        MIDISend(midiOutPort, currentMidiOutEndpoint, pktlist);
}


/************************************************** 
   THIS PART IS RELATED TO THE START/QUIT ACTIONS
 **************************************************/ 

- (void)awakeFromNib
{

// We test the running macos version
if (floor(NSAppKitVersionNumber) <= NSAppKitVersionNumber10_1) {

    NSRunAlertPanel(			NSLocalizedString(@"Attention", @"Description Forthcoming"), 
                                        NSLocalizedString(@"MacOSVersion", @"Description Forthcoming"), 
                                        NSLocalizedString(@"OK", @"Description Forthcoming"), 
                                        nil, 
                                        nil
                                );

    [ [NSApplication sharedApplication] terminate: self ];
} 


// Frequencies and times are represented with bits, but the value is not the real one: we need a table to convert 
// because it can't be calculated
// We have 256 values but only 128 can be sent
    char *timeTemp[256] = { "  30", "  31", "  32", "  33", "  34", "  35", "  36", "  37", "  38", "  39", "  40", "  41", "  42", "  43", "  44", "  45",
                            "  46", "  47", "  48", "  49", "  50", "  52", "  54", "  56", "  58", "  60", "  62", "  64", "  66", "  68", "  70", "  72",
                            "  74", "  76", "  78", "  80", "  82", "  84", "  86", "  88", "  90", "  92", "  94", "  96", "  98", " 100", " 105", " 110",
                            " 115", " 120", " 125", " 130", " 135", " 140", " 145", " 150", " 155", " 160", " 165", " 170", " 175", " 180", " 185", " 190",
                            " 195", " 200", " 205", " 210", " 215", " 220", " 225", " 230", " 235", " 240", " 245", " 250", " 255", " 260", " 265", " 270",
                            " 275", " 280", " 285", " 290", " 295", " 300", " 305", " 310", " 315", " 320", " 325", " 330", " 335", " 340", " 345", " 350", 
                            " 355", " 360", " 365", " 370", " 375", " 380", " 385", " 390", " 395", " 400", " 405", " 410", " 415", " 420", " 425", " 430", 
                            " 435", " 440", " 445", " 450", " 455", " 460", " 465", " 470", " 475", " 480", " 485", " 490", " 495", " 500", " 505", " 510", 
                            " 515", " 520", " 525", " 530", " 535", " 540", " 545", " 550", " 555", " 560", " 565", " 570", " 575", " 580", " 585", " 590", 
                            " 595", " 600", " 605", " 610", " 615", " 620", " 625", " 630", " 635", " 640", " 645", " 650", " 655", " 660", " 665", " 670", 
                            " 675", " 680", " 685", " 690", " 695", " 700", " 705", " 710", " 715", " 720", " 725", " 730", " 735", " 740", " 745", " 750", 
                            " 755", " 760", " 765", " 770", " 775", " 780", " 785", " 790", " 795", " 800", " 805", " 810", " 815", " 820", " 825", " 830", 
                            " 835", " 840", " 845", " 850", " 860", " 870", " 880", " 890", " 900", " 910", " 920", " 930", " 940", " 950", " 960", " 970", 
                            " 980", " 990", "1000", "1010", "1020", "1030", "1040", "1050", "1060", "1070", "1080", "1090", "1100", "1110", "1120", "1130", 
                            "1140", "1150", "1160", "1170", "1180", "1190", "1200", "1210", "1220", "1230", "1240", "1250", "1260", "1270", "1280", "1290", 
                            "1300", "1310", "1320", "1330", "1340", "1350", "1360", "1370", "1380", "1390", "1400", "1410", "1420", "1430", "1440", "1450" 
                        };


    char *freqTemp[256] = { "0.08", "0.09", "0.10", "0.11", "0.12", "0.13", "0.14", "0.15", "0.16", "0.17", "0.18", "0.19", "0.20", "0.21", "0.22", "0.23", 
                            "0.24", "0.25", "0.26", "0.27", "0.28", "0.29", "0.30", "0.31", "0.32", "0.33", "0.34", "0.35", "0.36", "0.37", "0.38", "0.39", 
                            "0.40", "0.41", "0.42", "0.43", "0.44", "0.45", "0.46", "0.47", "0.48", "0.49", "0.50", "0.51", "0.52", "0.53", "0.54", "0.55", 
                            "0.56", "0.57", "0.58", "0.59", "0.60", "0.61", "0.62", "0.63", "0.64", "0.65", "0.66", "0.67", "0.68", "0.69", "0.70", "0.71", 
                            "0.72", "0.73", "0.74", "0.75", "0.76", "0.77", "0.78", "0.79", "0.80", "0.81", "0.82", "0.83", "0.84", "0.85", "0.86", "0.87", 
                            "0.88", "0.89", "0.90", "0.91", "0.92", "0.93", "0.94", "0.95", "0.96", "0.97", "0.98", "0.99", "1.00", "1.04", "1.08", "1.12", 
                            "1.16", "1.20", "1.24", "1.28", "1.32", "1.36", "1.40", "1.44", "1.48", "1.52", "1.56", "1.60", "1.64", "1.68", "1.72", "1.76", 
                            "1.80", "1.84", "1.88", "1.92", "1.96", "2.00", "2.04", "2.08", "2.12", "2.16", "2.20", "2.24", "2.28", "2.32", "2.36", "2.40", 
                            "2.44", "2.48", "2.52", "2.56", "2.60", "2.64", "2.68", "2.72", "2.76", "2.80", "2.84", "2.88", "2.92", "2.96", "3.00", "3.04", 
                            "3.08", "3.12", "3.16", "3.20", "2.24", "3.28", "3.32", "3.36", "3.40", "3.44", "3.48", "3.52", "3.56", "3.60", "3.64", "3.68",
                            "3.72", "3.76", "3.80", "3.84", "3.88", "3.92", "3.96", "4.00", "4.04", "4.08", "4.12", "4.16", "4.20", "4.24", "4.28", "4.32", 
                            "4.36", "4.40", "4.44", "4.48", "4.52", "4.56", "4.60", "4.64", "4.68", "4.72", "4.76", "4.80", "4.84", "4.88", "4.92", "4.96", 
                            "5.00", "5.04", "5.12", "5.20", "5.28", "5.36", "5.44", "5.52", "5.60", "5.68", "5.76", "5.84", "5.92", "6.00", "6.08", "6.16", 
                            "6.24", "6.32", "6.40", "6.48", "6.56", "6.64", "6.72", "6.80", "6.88", "6.96", "7.04", "7.12", "7.20", "7.28", "7.36", "7.44", 
                            "7.52", "7.60", "7.68", "7.76", "7.84", "7.92", "8.00", "8.08", "8.16", "8.24", "8.32", "8.40", "8.48", "8.56", "8.64", "8.72", 
                            "8.80", "8.88", "8.96", "9.04", "9.12", "9.20", "9.28", "9.36", "9.44", "9.52", "9.60", "9.68", "9.76", "9.84", "9.92", "10.0"                                                                                               
                            }; 


// For others value, it could be calculated, but we use a table too.
    char *valueTemp[256] = { "1.00", "1.03", "1.07", "1.10", "1.14", "1.17", "1.21", "1.24", "1.28", "1.31", "1.35", "1.38", "1.42", "1.45", "1.49", "1.52",
                         "1.56", "1.60", "1.63", "1.67", "1.70", "1.74", "1.77", "1.81", "1.84", "1.88", "1.91", "1.95", "1.98", "2.02", "2.05", "2.09",
                         "2.12", "2.16", "2.20", "2.23", "2.27", "2.30", "2.34", "2.37", "2.41", "2.44", "2.48", "2.51", "2.55", "2.58", "2.62", "2.65",
                         "2.69", "2.72", "2.76", "2.80", "2.83", "2.87", "2.90", "2.94", "2.97", "3.01", "3.04", "3.08", "3.11", "3.15", "3.18", "3.22",
                         "3.25", "3.29", "3.32", "3.36", "3.40", "3.43", "3.47", "3.50", "3.54", "3.57", "3.61", "3.64", "3.68", "3.71", "3.75", "3.78",
                         "3.82", "3.85", "3.89", "3.92", "3.96", "4.00", "4.03", "4.07", "4.10", "4.14", "4.17", "4.21", "4.24", "4.28", "4.31", "4.35",
                         "4.38", "4.42", "4.45", "4.49", "4.52", "4.56", "4.60", "4.63", "4.67", "4.70", "4.74", "4.77", "4.81", "4.84", "4.88", "4.91",
                         "4.95", "4.98", "5.02", "5.05", "5.09", "5.12", "5.16", "5.20", "5.23", "5.27", "5.30", "5.34", "5.37", "5.41", "5.44", "5.48",
                         "5.51", "5.55", "5.58", "5.62", "5.65", "5.69", "5.72", "5.76", "5.80", "5.83", "5.87", "5.90", "5.94", "5.97", "6.01", "6.04",
                         "6.08", "6.11", "6.15", "6.18", "6.22", "6.25", "6.29", "6.32", "6.36", "6.40", "6.43", "6.47", "6.50", "6.54", "6.57", "6.61",
                         "6.64", "6.68", "6.71", "6.75", "6.78", "6.82", "6.85", "6.89", "6.92", "6.96", "7.00", "7.03", "7.07", "7.10", "7.14", "7.17",
                         "7.21", "7.24", "7.28", "7.31", "7.35", "7.38", "7.42", "7.45", "7.49", "7.52", "7.56", "7.60", "7.63", "7.67", "7.70", "7.74",
                         "7.77", "7.81", "7.84", "7.88", "7.91", "7.95", "7.98", "8.02", "8.05", "8.09", "8.12", "8.16", "8.20", "8.23", "8.27", "8.30",
                         "8.34", "8.37", "8.41", "8.44", "8.48", "8.51", "8.55", "8.58", "8.62", "8.65", "8.69", "8.72", "8.76", "8.80", "8.83", "8.87",
                         "8.90", "8.94", "8.97", "9.01", "9.04", "9.08", "9.11", "9.15", "9.18", "9.22", "9.25", "9.29", "9.32", "9.36", "9.39", "9.43",
                         "9.47", "9.50", "9.54", "9.57", "9.61", "9.64", "9.68", "9.71", "9.75", "9.78", "9.82", "9.85", "9.89", "9.92", "9.96", "10.0"
                        };

    pedalWahTable[0]="Baby's crying";
    pedalWahTable[1]="Real McQ";

    touchWahTable[0]="Low Q";
    touchWahTable[1]="High Q";

    int i,j;
    for (i=0;i<256;i++)
        for (j=0;j<4;j++)
        {
            timeTable[i][j]=timeTemp[i][j];
            freqTable[i][j]=freqTemp[i][j];
            valueTable[i][j]=valueTemp[i][j];
        }


// We read Preferences
        [ self readPreferences ];

// Initialization of the midi connection
	[ self midiInitialization: nil ];

// If problem: here's how to quit
//    [ [NSApplication sharedApplication] terminate: self ];
}


- (void) readPreferences
{
// We read, if exist, stored preferences
//   related to Open Recent Menu and the last Opened Directory

        NSUserDefaults *parameters = [NSUserDefaults standardUserDefaults];
    
        NSMenuItem *newItem;
        NSString *menuName  = [ parameters objectForKey:@"openRecent0"];
        NSString *menuPath = [ parameters objectForKey:@"openRecent0Path"];
        if (menuName && menuPath)
        {
            newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:menuName action:NULL keyEquivalent:@""];
            [newItem setTag:0];
            [newItem setTarget:self];
            [newItem setAction:@selector(openRecent:)];
            [newItem setRepresentedObject: (id)menuPath ];
            [openRecentMenu addItem:newItem];
            [newItem release];
        }

        menuName  = [ parameters objectForKey:@"openRecent1"];
        menuPath = [ parameters objectForKey:@"openRecent1Path"];
        if (menuName && menuPath)
        {
            newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:menuName action:NULL keyEquivalent:@""];
            [newItem setTag:1];
            [newItem setTarget:self];
            [newItem setAction:@selector(openRecent:)];
            [newItem setRepresentedObject: (id)menuPath ];
            [openRecentMenu addItem:newItem];
            [newItem release];
        }
        
        menuName  = [ parameters objectForKey:@"openRecent2"];
        menuPath = [ parameters objectForKey:@"openRecent2Path"];
        if (menuName && menuPath)
        {
            newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:menuName action:NULL keyEquivalent:@""];
            [newItem setTag:2];
            [newItem setTarget:self];
            [newItem setAction:@selector(openRecent:)];
            [newItem setRepresentedObject: (id)menuPath ];
            [openRecentMenu addItem:newItem];
            [newItem release];
        }

        menuName  = [ parameters objectForKey:@"openRecent3"];
        menuPath = [ parameters objectForKey:@"openRecent3Path"];
        if (menuName && menuPath)
        {
            newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:menuName action:NULL keyEquivalent:@""];
            [newItem setTag:3];
            [newItem setTarget:self];
            [newItem setAction:@selector(openRecent:)];
            [newItem setRepresentedObject: (id)menuPath ];
            [openRecentMenu addItem:newItem];
            [newItem release];
        }

        menuName  = [ parameters objectForKey:@"openRecent4"];
        menuPath = [ parameters objectForKey:@"openRecent4Path"];
        if (menuName && menuPath)
        {
            newItem = [[NSMenuItem allocWithZone:[NSMenu menuZone]] initWithTitle:menuName action:NULL keyEquivalent:@""];
            [newItem setTag:4];
            [newItem setTarget:self];
            [newItem setAction:@selector(openRecent:)];
            [newItem setRepresentedObject: (id)menuPath ];
            [openRecentMenu addItem:newItem];
            [newItem release];
        }
        
        
        if ( [ parameters objectForKey:@"NSDefaultOpenDirectory"] )
            currentDirectory = [[ NSString alloc] initWithString: [[NSUserDefaults standardUserDefaults] objectForKey:@"NSDefaultOpenDirectory"]];
}

- (IBAction)quit:(id)sender
{
    // We disconnect all midi
    MIDIPortDisconnectSource(midiInPort, currentMidiInEndpoint);
    MIDIPortDisconnectSource(midiOutPort, currentMidiOutEndpoint);    
    MIDIClientDispose(midiClient);

    // First we store everything
    if ([ openRecentMenu numberOfItems ]>0)
    {
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 0 ] title ]	forKey:@"openRecent0" ];
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 0 ] representedObject] forKey:@"openRecent0Path" ];
    }
    if ([ openRecentMenu numberOfItems ]>1)
    {
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 1 ] title ]	forKey:@"openRecent1" ];
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 1 ] representedObject] forKey:@"openRecent1Path" ];
    }
    if ([ openRecentMenu numberOfItems ]>2)
    {
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 2 ] title ]	forKey:@"openRecent2" ];
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 2 ] representedObject] forKey:@"openRecent2Path" ];
    }
    if ([ openRecentMenu numberOfItems ]>3)
    {
	[[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 3 ] title ]	forKey:@"openRecent3" ];
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 3 ] representedObject] forKey:@"openRecent3Path" ];
    }
    if ([ openRecentMenu numberOfItems ]>4)
    {
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 4 ] title ]	forKey:@"openRecent4" ];
        [[NSUserDefaults standardUserDefaults] setObject:  [[ openRecentMenu itemAtIndex: 4 ] representedObject] forKey:@"openRecent4Path" ];
    }

 
    // And then we quit
    [ [NSApplication sharedApplication] terminate: self ];
}


@end
